ITEMLINK_COLOR_TEXT = "|cff70b8e0"
ITEMLINK_COLOR_TEXT_2 = "|cffffffff"
ITEMLINK_COLOR_MATCH = "|cffee0000"

ITEMLINK_DB = nil
ITEMLINK_REFRESH_DB = false

ITEMLINK_MAX_SEARCH = 100000

function getDatabase()
	if ITEMLINK_DB == nil or ITEMLINK_REFRESH_DB == true then
		ITEMLINK_DB = {}
		ITEMLINK_REFRESH_DB = false
		for i=0, ITEMLINK_MAX_SEARCH do
			datas = ItemLink_RequestLink(i)
			if datas ~= nil then
				ITEMLINK_DB[i] = datas
			end
		end
	end
	
	return ITEMLINK_DB
end	

function ItemLink_RequestLink(itemid)
	local itemName, itemLink = GetItemInfo( itemid )
	if( itemLink ) then
		return {string.lower(itemName), itemLink}
	else
		return nil
	end
end

function ItemLink_Search(query)
	found = 0
	query = string.lower(query)
	DEFAULT_CHAT_FRAME:AddMessage(ITEMLINK_COLOR_TEXT .. "Searching for items containing search string '"..ITEMLINK_COLOR_TEXT_2..query..ITEMLINK_COLOR_TEXT.."'.") 
	for key, value in pairs(getDatabase()) do
		if string.find(value[1], query) then
			DEFAULT_CHAT_FRAME:AddMessage(ITEMLINK_COLOR_TEXT .. "Item: ".. value[2]) 
			found = found + 1
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage(ITEMLINK_COLOR_TEXT .. "Search completed, "..ITEMLINK_COLOR_TEXT_2..found..ITEMLINK_COLOR_TEXT.." items matched.") 
end

function ItemLink_Command(msg)
	if tonumber(msg) then
		link = getDatabase()[tonumber(msg)];
		if link == nil then
			DEFAULT_CHAT_FRAME:AddMessage(ITEMLINK_COLOR_TEXT.."Item "..ITEMLINK_COLOR_TEXT_2..msg..ITEMLINK_COLOR_TEXT..
				" is undiscovered, |cffffffff|Hitem:"..msg..":0:0:0:0:0:0:0|h[click here]|h"..ITEMLINK_COLOR_TEXT.." to query.")
				
			ITEMLINK_REFRESH_DB = true
		else
			DEFAULT_CHAT_FRAME:AddMessage(ITEMLINK_COLOR_TEXT .. "Item "..ITEMLINK_COLOR_TEXT_2..msg..ITEMLINK_COLOR_TEXT.." is "..link[2]) 
		end
	else
		ItemLink_Search(msg)
	end
end


SLASH_ILINK1 = "/link"
SLASH_ILINK2 = "/itemlink"
SlashCmdList["ILINK"] = ItemLink_Command

